/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import org.richfaces.component.UIColumnGroup ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.ColumnGroup
 * Component-Family org.richfaces.ColumnGroup
  	 * Renderer-Type org.richfaces.ColumnGroupRenderer
  	 * 
 */
 public class HtmlColumnGroup extends org.richfaces.component.UIColumnGroup {

  public static final String COMPONENT_TYPE = "org.richfaces.ColumnGroup";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlColumnGroup (){
  	  	setRendererType("org.richfaces.ColumnGroupRenderer");
  	  }

// Component properties fields
 	/**
	 * styleClass
	 * Corresponds to the HTML class attribute
	 */
	 	 private String  _styleClass = null; /* Default is null*/
	 	  	/**
	 * rowClasses
	 * 
	 */
	 	 private String  _rowClasses = null; /* Default is null*/
	 	  	/**
	 * title
	 * Advisory title information about markup elements generated for this component
	 */
	 	 private String  _title = null; /* Default is null*/
	 	  	/**
	 * lang
	 * Code describing the language used in the generated markup for this component
	 */
	 	 private String  _lang = null; /* Default is null*/
	 	   	/**
	 * columnClasses
	 * 
	 */
	 	 private String  _columnClasses = null; /* Default is null*/
	 	  	/**
	 * style
	 * CSS style(s) is/are to be applied when this component is rendered
	 */
	 	 private String  _style = null; /* Default is null*/
	 	    	/**
	 * dir
	 * Alternate textual description of the element rendered by this component
	 */
	 	 private String  _dir = null; /* Default is null*/
	 	  
// Getters-setters
 	/*
	 * Corresponds to the HTML class attribute
	 * Setter for styleClass
	 * @param styleClass - new value
	 */
	 public void setStyleClass( String  __styleClass ){
		this._styleClass = __styleClass;
	 	 }


	/*
	 * Corresponds to the HTML class attribute
	 * Getter for styleClass
	 * @return styleClass value from local variable or value bindings
	 */
	 public String getStyleClass(  ){
	         if (null != this._styleClass)
        {
            return this._styleClass;
        	    }
        ValueBinding vb = getValueBinding("styleClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * 
	 * Setter for rowClasses
	 * @param rowClasses - new value
	 */
	 public void setRowClasses( String  __rowClasses ){
		this._rowClasses = __rowClasses;
	 	 }


	/*
	 * 
	 * Getter for rowClasses
	 * @return rowClasses value from local variable or value bindings
	 */
	 public String getRowClasses(  ){
	         if (null != this._rowClasses)
        {
            return this._rowClasses;
        	    }
        ValueBinding vb = getValueBinding("rowClasses");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Advisory title information about markup elements generated for this component
	 * Setter for title
	 * @param title - new value
	 */
	 public void setTitle( String  __title ){
		this._title = __title;
	 	 }


	/*
	 * Advisory title information about markup elements generated for this component
	 * Getter for title
	 * @return title value from local variable or value bindings
	 */
	 public String getTitle(  ){
	         if (null != this._title)
        {
            return this._title;
        	    }
        ValueBinding vb = getValueBinding("title");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Code describing the language used in the generated markup for this component
	 * Setter for lang
	 * @param lang - new value
	 */
	 public void setLang( String  __lang ){
		this._lang = __lang;
	 	 }


	/*
	 * Code describing the language used in the generated markup for this component
	 * Getter for lang
	 * @return lang value from local variable or value bindings
	 */
	 public String getLang(  ){
	         if (null != this._lang)
        {
            return this._lang;
        	    }
        ValueBinding vb = getValueBinding("lang");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * 
	 * Setter for columnClasses
	 * @param columnClasses - new value
	 */
	 public void setColumnClasses( String  __columnClasses ){
		this._columnClasses = __columnClasses;
	 	 }


	/*
	 * 
	 * Getter for columnClasses
	 * @return columnClasses value from local variable or value bindings
	 */
	 public String getColumnClasses(  ){
	         if (null != this._columnClasses)
        {
            return this._columnClasses;
        	    }
        ValueBinding vb = getValueBinding("columnClasses");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Setter for style
	 * @param style - new value
	 */
	 public void setStyle( String  __style ){
		this._style = __style;
	 	 }


	/*
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Getter for style
	 * @return style value from local variable or value bindings
	 */
	 public String getStyle(  ){
	         if (null != this._style)
        {
            return this._style;
        	    }
        ValueBinding vb = getValueBinding("style");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     	/*
	 * Alternate textual description of the element rendered by this component
	 * Setter for dir
	 * @param dir - new value
	 */
	 public void setDir( String  __dir ){
		this._dir = __dir;
	 	 }


	/*
	 * Alternate textual description of the element rendered by this component
	 * Getter for dir
	 * @return dir value from local variable or value bindings
	 */
	 public String getDir(  ){
	         if (null != this._dir)
        {
            return this._dir;
        	    }
        ValueBinding vb = getValueBinding("dir");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.ColumnGroup";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[8];
        values[0] = super.saveState(context);
 	 	          values[1] = _styleClass;
	   	 	
  	 	          values[2] = _rowClasses;
	   	 	
  	 	          values[3] = _title;
	   	 	
  	 	          values[4] = _lang;
	   	 	
   	 	          values[5] = _columnClasses;
	   	 	
  	 	          values[6] = _style;
	   	 	
    	 	          values[7] = _dir;
	   	 	
  	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	 	          _styleClass = (String)values[1] ;
	   	 	
  	 	          _rowClasses = (String)values[2] ;
	   	 	
  	 	          _title = (String)values[3] ;
	   	 	
  	 	          _lang = (String)values[4] ;
	   	 	
   	 	          _columnClasses = (String)values[5] ;
	   	 	
  	 	          _style = (String)values[6] ;
	   	 	
    	 	          _dir = (String)values[7] ;
	   	 	
  	
		
	}	
// Utilites

}