/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import java.lang.Object ;
import org.richfaces.component.UIDndParam ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.DndParam
 * Component-Family org.richfaces.DndParam
  	 * A component is used for parameters transmission in Drag and Drop operations. It's also used for dragIndicator elements definition with transmitting some values for rendering in it.
 */
 public class HtmlDndParam extends org.richfaces.component.UIDndParam {

  public static final String COMPONENT_TYPE = "org.richfaces.DndParam";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlDndParam (){
  	  }

// Component properties fields
 	/**
	 * value
	 * value
	 */
	 	 private Object  _value = null; /* Default is null*/
	 	  	/**
	 * type
	 * type
	 */
	 	 private String  _type = null; /* Default is "default"*/
	 	    	/**
	 * name
	 * 
	 */
	 	 private String  _name = null; /* Default is null*/
	 	  
// Getters-setters
 	/*
	 * value
	 * Setter for value
	 * @param value - new value
	 */
	 public void setValue( Object  __value ){
		this._value = __value;
	 	 }


	/*
	 * value
	 * Getter for value
	 * @return value value from local variable or value bindings
	 */
	 public Object getValue(  ){
	         if (null != this._value)
        {
            return this._value;
        	    }
        ValueBinding vb = getValueBinding("value");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * type
	 * Setter for type
	 * @param type - new value
	 */
	 public void setType( String  __type ){
		this._type = __type;
	 	 }


	/*
	 * type
	 * Getter for type
	 * @return type value from local variable or value bindings
	 */
	 public String getType(  ){
	         if (null != this._type)
        {
            return this._type;
        	    }
        ValueBinding vb = getValueBinding("type");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "default";
        }
	 	 }
	     	/*
	 * 
	 * Setter for name
	 * @param name - new value
	 */
	 public void setName( String  __name ){
		this._name = __name;
	 	 }


	/*
	 * 
	 * Getter for name
	 * @return name value from local variable or value bindings
	 */
	 public String getName(  ){
	         if (null != this._name)
        {
            return this._name;
        	    }
        ValueBinding vb = getValueBinding("name");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.DndParam";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[4];
        values[0] = super.saveState(context);
 	 	          values[1] = _value;
	   	 	
  	 	          values[2] = _type;
	   	 	
    	 	          values[3] = _name;
	   	 	
  	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	 	          _value = (Object)values[1] ;
	   	 	
  	 	          _type = (String)values[2] ;
	   	 	
    	 	          _name = (String)values[3] ;
	   	 	
  	
		
	}	
// Utilites

}