/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import java.lang.Object ;
import javax.faces.el.MethodBinding ;
import org.richfaces.component.UIDropSupport ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.DropSupport
 * Component-Family org.richfaces.DropSupport
  	 * Renderer-Type org.richfaces.DropSupportRenderer
  	 * 
 */
 public class HtmlDropSupport extends org.richfaces.component.UIDropSupport {

  public static final String COMPONENT_TYPE = "org.richfaces.DropSupport";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlDropSupport (){
  	  	setRendererType("org.richfaces.DropSupportRenderer");
  	  }

// Component properties fields
  	/**
	 * ondragenter
	 * A JavaScript event handler called on enter draggable object to zone.
	 */
	 	 private String  _ondragenter = null; /* Default is null*/
	 	    	/**
	 * oncomplete
	 * oncomplete
	 */
	 	 private String  _oncomplete = null; /* Default is null*/
	 	   	/**
	 * reRender
	 * reRender
	 */
	 	 private Object  _reRender = null; /* Default is null*/
	 	   	/**
	 * disableDefault
	 * disableDefault
	 */
	 	 private boolean  _disableDefault = false;		
	/**
	 * Flag indicated what disableDefault is set.
	 */
	 private boolean _disableDefaultSet = false;	
	 	  	/**
	 * bypassUpdates
	 * bypassUpdates
	 */
	 	 private boolean  _bypassUpdates = false;		
	/**
	 * Flag indicated what bypassUpdates is set.
	 */
	 private boolean _bypassUpdatesSet = false;	
	 	  	/**
	 * ondropend
	 * 
	 */
	 	 private String  _ondropend = null; /* Default is null*/
	 	  	/**
	 * limitToList
	 * limitToList
	 */
	 	 private boolean  _limitToList = false;		
	/**
	 * Flag indicated what limitToList is set.
	 */
	 private boolean _limitToListSet = false;	
	 	  	/**
	 * ajaxSingle
	 * ajaxSingle
	 */
	 	 private boolean  _ajaxSingle = false;		
	/**
	 * Flag indicated what ajaxSingle is set.
	 */
	 private boolean _ajaxSingleSet = false;	
	 	  	/**
	 * onsubmit
	 * onsubmit
	 */
	 	 private String  _onsubmit = null; /* Default is null*/
	 	  	/**
	 * ondrop
	 * A JavaScript event handler called after a drag object is dropped to zone.
	 */
	 	 private String  _ondrop = null; /* Default is null*/
	 	     	/**
	 * timeout
	 * timeout
	 */
	 	 private int  _timeout = Integer.MIN_VALUE;		
	/**
	 * Flag indicated what timeout is set.
	 */
	 private boolean _timeoutSet = false;	
	 	   	/**
	 * acceptedTypes
	 * List of drag types to be processd by the current drop zone.
	 */
	 	 private Object  _acceptedTypes = null; /* Default is null*/
	 	  	/**
	 * dropValue
	 * Data to be processed after a drop event.
	 */
	 	 private Object  _dropValue = null; /* Default is null*/
	 	  	/**
	 * dropListener
	 * dropListener
	 */
	 	 private MethodBinding  _dropListener = null; /* Default is null*/
	 	  	/**
	 * status
	 * status
	 */
	 	 private String  _status = null; /* Default is null*/
	 	  	/**
	 * requestDelay
	 * requestDelay
	 */
	 	 private int  _requestDelay = Integer.MIN_VALUE;		
	/**
	 * Flag indicated what requestDelay is set.
	 */
	 private boolean _requestDelaySet = false;	
	 	  	/**
	 * eventsQueue
	 * eventsQueue
	 */
	 	 private String  _eventsQueue = null; /* Default is null*/
	 	  	/**
	 * ondragexit
	 * A JavaScript event handler called after a drag object leaves zone.
	 */
	 	 private String  _ondragexit = null; /* Default is null*/
	 	   	/**
	 * data
	 * data
	 */
	 	 private Object  _data = null; /* Default is null*/
	 	    	/**
	 * ignoreDupResponses
	 * ignoreDupResponses
	 */
	 	 private boolean  _ignoreDupResponses = false;		
	/**
	 * Flag indicated what ignoreDupResponses is set.
	 */
	 private boolean _ignoreDupResponsesSet = false;	
	 	  	/**
	 * typeMapping
	 * Map between a draggable type and an indicator name on zone. it's defined with the pair (drag type:indicator name))
	 */
	 	 private Object  _typeMapping = null; /* Default is null*/
	 	  
// Getters-setters
  	/*
	 * A JavaScript event handler called on enter draggable object to zone.
	 * Setter for ondragenter
	 * @param ondragenter - new value
	 */
	 public void setOndragenter( String  __ondragenter ){
		this._ondragenter = __ondragenter;
	 	 }


	/*
	 * A JavaScript event handler called on enter draggable object to zone.
	 * Getter for ondragenter
	 * @return ondragenter value from local variable or value bindings
	 */
	 public String getOndragenter(  ){
	         if (null != this._ondragenter)
        {
            return this._ondragenter;
        	    }
        ValueBinding vb = getValueBinding("ondragenter");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     	/*
	 * oncomplete
	 * Setter for oncomplete
	 * @param oncomplete - new value
	 */
	 public void setOncomplete( String  __oncomplete ){
		this._oncomplete = __oncomplete;
	 	 }


	/*
	 * oncomplete
	 * Getter for oncomplete
	 * @return oncomplete value from local variable or value bindings
	 */
	 public String getOncomplete(  ){
	         if (null != this._oncomplete)
        {
            return this._oncomplete;
        	    }
        ValueBinding vb = getValueBinding("oncomplete");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * reRender
	 * Setter for reRender
	 * @param reRender - new value
	 */
	 public void setReRender( Object  __reRender ){
		this._reRender = __reRender;
	 	 }


	/*
	 * reRender
	 * Getter for reRender
	 * @return reRender value from local variable or value bindings
	 */
	 public Object getReRender(  ){
	         if (null != this._reRender)
        {
            return this._reRender;
        	    }
        ValueBinding vb = getValueBinding("reRender");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * disableDefault
	 * Setter for disableDefault
	 * @param disableDefault - new value
	 */
	 public void setDisableDefault( boolean  __disableDefault ){
		this._disableDefault = __disableDefault;
	 		this._disableDefaultSet = true;
	 	 }


	/*
	 * disableDefault
	 * Getter for disableDefault
	 * @return disableDefault value from local variable or value bindings
	 */
	 public boolean isDisableDefault(  ){
	 		 if(this._disableDefaultSet){
			return this._disableDefault;
		 }
    	ValueBinding vb = getValueBinding("disableDefault");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._disableDefault;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._disableDefault);
    	}
	 	 }
	   	/*
	 * bypassUpdates
	 * Setter for bypassUpdates
	 * @param bypassUpdates - new value
	 */
	 public void setBypassUpdates( boolean  __bypassUpdates ){
		this._bypassUpdates = __bypassUpdates;
	 		this._bypassUpdatesSet = true;
	 	 }


	/*
	 * bypassUpdates
	 * Getter for bypassUpdates
	 * @return bypassUpdates value from local variable or value bindings
	 */
	 public boolean isBypassUpdates(  ){
	 		 if(this._bypassUpdatesSet){
			return this._bypassUpdates;
		 }
    	ValueBinding vb = getValueBinding("bypassUpdates");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._bypassUpdates;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._bypassUpdates);
    	}
	 	 }
	   	/*
	 * 
	 * Setter for ondropend
	 * @param ondropend - new value
	 */
	 public void setOndropend( String  __ondropend ){
		this._ondropend = __ondropend;
	 	 }


	/*
	 * 
	 * Getter for ondropend
	 * @return ondropend value from local variable or value bindings
	 */
	 public String getOndropend(  ){
	         if (null != this._ondropend)
        {
            return this._ondropend;
        	    }
        ValueBinding vb = getValueBinding("ondropend");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * limitToList
	 * Setter for limitToList
	 * @param limitToList - new value
	 */
	 public void setLimitToList( boolean  __limitToList ){
		this._limitToList = __limitToList;
	 		this._limitToListSet = true;
	 	 }


	/*
	 * limitToList
	 * Getter for limitToList
	 * @return limitToList value from local variable or value bindings
	 */
	 public boolean isLimitToList(  ){
	 		 if(this._limitToListSet){
			return this._limitToList;
		 }
    	ValueBinding vb = getValueBinding("limitToList");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._limitToList;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._limitToList);
    	}
	 	 }
	   	/*
	 * ajaxSingle
	 * Setter for ajaxSingle
	 * @param ajaxSingle - new value
	 */
	 public void setAjaxSingle( boolean  __ajaxSingle ){
		this._ajaxSingle = __ajaxSingle;
	 		this._ajaxSingleSet = true;
	 	 }


	/*
	 * ajaxSingle
	 * Getter for ajaxSingle
	 * @return ajaxSingle value from local variable or value bindings
	 */
	 public boolean isAjaxSingle(  ){
	 		 if(this._ajaxSingleSet){
			return this._ajaxSingle;
		 }
    	ValueBinding vb = getValueBinding("ajaxSingle");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._ajaxSingle;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._ajaxSingle);
    	}
	 	 }
	   	/*
	 * onsubmit
	 * Setter for onsubmit
	 * @param onsubmit - new value
	 */
	 public void setOnsubmit( String  __onsubmit ){
		this._onsubmit = __onsubmit;
	 	 }


	/*
	 * onsubmit
	 * Getter for onsubmit
	 * @return onsubmit value from local variable or value bindings
	 */
	 public String getOnsubmit(  ){
	         if (null != this._onsubmit)
        {
            return this._onsubmit;
        	    }
        ValueBinding vb = getValueBinding("onsubmit");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * A JavaScript event handler called after a drag object is dropped to zone.
	 * Setter for ondrop
	 * @param ondrop - new value
	 */
	 public void setOndrop( String  __ondrop ){
		this._ondrop = __ondrop;
	 	 }


	/*
	 * A JavaScript event handler called after a drag object is dropped to zone.
	 * Getter for ondrop
	 * @return ondrop value from local variable or value bindings
	 */
	 public String getOndrop(  ){
	         if (null != this._ondrop)
        {
            return this._ondrop;
        	    }
        ValueBinding vb = getValueBinding("ondrop");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      	/*
	 * timeout
	 * Setter for timeout
	 * @param timeout - new value
	 */
	 public void setTimeout( int  __timeout ){
		this._timeout = __timeout;
	 		this._timeoutSet = true;
	 	 }


	/*
	 * timeout
	 * Getter for timeout
	 * @return timeout value from local variable or value bindings
	 */
	 public int getTimeout(  ){
	 		 if(this._timeoutSet){
			return this._timeout;
		 }
    	ValueBinding vb = getValueBinding("timeout");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._timeout;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._timeout);
    	}
	 	 }
	    	/*
	 * List of drag types to be processd by the current drop zone.
	 * Setter for acceptedTypes
	 * @param acceptedTypes - new value
	 */
	 public void setAcceptedTypes( Object  __acceptedTypes ){
		this._acceptedTypes = __acceptedTypes;
	 	 }


	/*
	 * List of drag types to be processd by the current drop zone.
	 * Getter for acceptedTypes
	 * @return acceptedTypes value from local variable or value bindings
	 */
	 public Object getAcceptedTypes(  ){
	         if (null != this._acceptedTypes)
        {
            return this._acceptedTypes;
        	    }
        ValueBinding vb = getValueBinding("acceptedTypes");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Data to be processed after a drop event.
	 * Setter for dropValue
	 * @param dropValue - new value
	 */
	 public void setDropValue( Object  __dropValue ){
		this._dropValue = __dropValue;
	 	 }


	/*
	 * Data to be processed after a drop event.
	 * Getter for dropValue
	 * @return dropValue value from local variable or value bindings
	 */
	 public Object getDropValue(  ){
	         if (null != this._dropValue)
        {
            return this._dropValue;
        	    }
        ValueBinding vb = getValueBinding("dropValue");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * dropListener
	 * Setter for dropListener
	 * @param dropListener - new value
	 */
	 public void setDropListener( MethodBinding  __dropListener ){
		this._dropListener = __dropListener;
	 	 }


	/*
	 * dropListener
	 * Getter for dropListener
	 * @return dropListener value from local variable or value bindings
	 */
	 public MethodBinding getDropListener(  ){
	         if (null != this._dropListener)
        {
            return this._dropListener;
                } else {
            return null;
        }
	 	 }
	   	/*
	 * status
	 * Setter for status
	 * @param status - new value
	 */
	 public void setStatus( String  __status ){
		this._status = __status;
	 	 }


	/*
	 * status
	 * Getter for status
	 * @return status value from local variable or value bindings
	 */
	 public String getStatus(  ){
	         if (null != this._status)
        {
            return this._status;
        	    }
        ValueBinding vb = getValueBinding("status");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * requestDelay
	 * Setter for requestDelay
	 * @param requestDelay - new value
	 */
	 public void setRequestDelay( int  __requestDelay ){
		this._requestDelay = __requestDelay;
	 		this._requestDelaySet = true;
	 	 }


	/*
	 * requestDelay
	 * Getter for requestDelay
	 * @return requestDelay value from local variable or value bindings
	 */
	 public int getRequestDelay(  ){
	 		 if(this._requestDelaySet){
			return this._requestDelay;
		 }
    	ValueBinding vb = getValueBinding("requestDelay");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._requestDelay;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._requestDelay);
    	}
	 	 }
	   	/*
	 * eventsQueue
	 * Setter for eventsQueue
	 * @param eventsQueue - new value
	 */
	 public void setEventsQueue( String  __eventsQueue ){
		this._eventsQueue = __eventsQueue;
	 	 }


	/*
	 * eventsQueue
	 * Getter for eventsQueue
	 * @return eventsQueue value from local variable or value bindings
	 */
	 public String getEventsQueue(  ){
	         if (null != this._eventsQueue)
        {
            return this._eventsQueue;
        	    }
        ValueBinding vb = getValueBinding("eventsQueue");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * A JavaScript event handler called after a drag object leaves zone.
	 * Setter for ondragexit
	 * @param ondragexit - new value
	 */
	 public void setOndragexit( String  __ondragexit ){
		this._ondragexit = __ondragexit;
	 	 }


	/*
	 * A JavaScript event handler called after a drag object leaves zone.
	 * Getter for ondragexit
	 * @return ondragexit value from local variable or value bindings
	 */
	 public String getOndragexit(  ){
	         if (null != this._ondragexit)
        {
            return this._ondragexit;
        	    }
        ValueBinding vb = getValueBinding("ondragexit");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * data
	 * Setter for data
	 * @param data - new value
	 */
	 public void setData( Object  __data ){
		this._data = __data;
	 	 }


	/*
	 * data
	 * Getter for data
	 * @return data value from local variable or value bindings
	 */
	 public Object getData(  ){
	         if (null != this._data)
        {
            return this._data;
        	    }
        ValueBinding vb = getValueBinding("data");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     	/*
	 * ignoreDupResponses
	 * Setter for ignoreDupResponses
	 * @param ignoreDupResponses - new value
	 */
	 public void setIgnoreDupResponses( boolean  __ignoreDupResponses ){
		this._ignoreDupResponses = __ignoreDupResponses;
	 		this._ignoreDupResponsesSet = true;
	 	 }


	/*
	 * ignoreDupResponses
	 * Getter for ignoreDupResponses
	 * @return ignoreDupResponses value from local variable or value bindings
	 */
	 public boolean isIgnoreDupResponses(  ){
	 		 if(this._ignoreDupResponsesSet){
			return this._ignoreDupResponses;
		 }
    	ValueBinding vb = getValueBinding("ignoreDupResponses");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._ignoreDupResponses;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._ignoreDupResponses);
    	}
	 	 }
	   	/*
	 * Map between a draggable type and an indicator name on zone. it's defined with the pair (drag type:indicator name))
	 * Setter for typeMapping
	 * @param typeMapping - new value
	 */
	 public void setTypeMapping( Object  __typeMapping ){
		this._typeMapping = __typeMapping;
	 	 }


	/*
	 * Map between a draggable type and an indicator name on zone. it's defined with the pair (drag type:indicator name))
	 * Getter for typeMapping
	 * @return typeMapping value from local variable or value bindings
	 */
	 public Object getTypeMapping(  ){
	         if (null != this._typeMapping)
        {
            return this._typeMapping;
        	    }
        ValueBinding vb = getValueBinding("typeMapping");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.DropSupport";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[29];
        values[0] = super.saveState(context);
  	 	          values[1] = _ondragenter;
	   	 	
    	 	          values[2] = _oncomplete;
	   	 	
   	 	          values[3] = _reRender;
	   	 	
   	        values[4] = new Boolean(_disableDefault);
	   	   values[5] = Boolean.valueOf(_disableDefaultSet);	
	   	 	
  	        values[6] = new Boolean(_bypassUpdates);
	   	   values[7] = Boolean.valueOf(_bypassUpdatesSet);	
	   	 	
  	 	          values[8] = _ondropend;
	   	 	
  	        values[9] = new Boolean(_limitToList);
	   	   values[10] = Boolean.valueOf(_limitToListSet);	
	   	 	
  	        values[11] = new Boolean(_ajaxSingle);
	   	   values[12] = Boolean.valueOf(_ajaxSingleSet);	
	   	 	
  	 	          values[13] = _onsubmit;
	   	 	
  	 	          values[14] = _ondrop;
	   	 	
     	        values[15] = new Integer(_timeout);
	   	   values[16] = Boolean.valueOf(_timeoutSet);	
	   	 	
   	 	          values[17] = _acceptedTypes;
	   	 	
  	 	          values[18] = _dropValue;
	   	 	
  	 	          values[19] = saveAttachedState(context, _dropListener );		
	   	 	
  	 	          values[20] = _status;
	   	 	
  	        values[21] = new Integer(_requestDelay);
	   	   values[22] = Boolean.valueOf(_requestDelaySet);	
	   	 	
  	 	          values[23] = _eventsQueue;
	   	 	
  	 	          values[24] = _ondragexit;
	   	 	
   	 	          values[25] = _data;
	   	 	
    	        values[26] = new Boolean(_ignoreDupResponses);
	   	   values[27] = Boolean.valueOf(_ignoreDupResponsesSet);	
	   	 	
  	 	          values[28] = _typeMapping;
	   	 	
  	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
  	 	          _ondragenter = (String)values[1] ;
	   	 	
    	 	          _oncomplete = (String)values[2] ;
	   	 	
   	 	          _reRender = (Object)values[3] ;
	   	 	
   	        _disableDefault = ((Boolean)values[4]).booleanValue();
	   	   _disableDefaultSet = ((Boolean)values[5]).booleanValue();	
	   	 	
  	        _bypassUpdates = ((Boolean)values[6]).booleanValue();
	   	   _bypassUpdatesSet = ((Boolean)values[7]).booleanValue();	
	   	 	
  	 	          _ondropend = (String)values[8] ;
	   	 	
  	        _limitToList = ((Boolean)values[9]).booleanValue();
	   	   _limitToListSet = ((Boolean)values[10]).booleanValue();	
	   	 	
  	        _ajaxSingle = ((Boolean)values[11]).booleanValue();
	   	   _ajaxSingleSet = ((Boolean)values[12]).booleanValue();	
	   	 	
  	 	          _onsubmit = (String)values[13] ;
	   	 	
  	 	          _ondrop = (String)values[14] ;
	   	 	
     	        _timeout = ((Integer)values[15]).intValue();
	   	   _timeoutSet = ((Boolean)values[16]).booleanValue();	
	   	 	
   	 	          _acceptedTypes = (Object)values[17] ;
	   	 	
  	 	          _dropValue = (Object)values[18] ;
	   	 	
  	 	          _dropListener = (MethodBinding)restoreAttachedState(context,values[19] );		
	   	 	
  	 	          _status = (String)values[20] ;
	   	 	
  	        _requestDelay = ((Integer)values[21]).intValue();
	   	   _requestDelaySet = ((Boolean)values[22]).booleanValue();	
	   	 	
  	 	          _eventsQueue = (String)values[23] ;
	   	 	
  	 	          _ondragexit = (String)values[24] ;
	   	 	
   	 	          _data = (Object)values[25] ;
	   	 	
    	        _ignoreDupResponses = ((Boolean)values[26]).booleanValue();
	   	   _ignoreDupResponsesSet = ((Boolean)values[27]).booleanValue();	
	   	 	
  	 	          _typeMapping = (Object)values[28] ;
	   	 	
  	
		
	}	
// Utilites

}