/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import org.richfaces.component.UIPanelBar ;
import java.lang.String ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.PanelBar
 * Component-Family org.richfaces.PanelBar
  	 * Renderer-Type org.richfaces.PanelBarRenderer
  	 * A component with categories sliding up and down to reveal and hide items under selected
			categories (as used in Microsoft Outlook).
 */
 public class HtmlPanelBar extends org.richfaces.component.UIPanelBar {

  public static final String COMPONENT_TYPE = "org.richfaces.PanelBar";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlPanelBar (){
  	  	setRendererType("org.richfaces.PanelBarRenderer");
  	  }

// Component properties fields
 	/**
	 * contentClass
	 * The component content style class
	 */
	 	 private String  _contentClass = null; /* Default is null*/
	 	  	/**
	 * headerStyle
	 * The component header style
	 */
	 	 private String  _headerStyle = null; /* Default is ""*/
	 	  	/**
	 * styleClass
	 * The component style class
	 */
	 	 private String  _styleClass = null; /* Default is null*/
	 	  	/**
	 * width
	 * The width of the slide panel. Might be defined as pixels or as percentage.
	    	The default width is 100%
	 */
	 	 private String  _width = null; /* Default is "100%"*/
	 	  	/**
	 * height
	 * The height of the slide panel. Might be defined as pixels or as percentage.
	    	The default height is 100%
	 */
	 	 private String  _height = null; /* Default is "100%"*/
	 	  	/**
	 * contentStyle
	 * The component content style
	 */
	 	 private String  _contentStyle = null; /* Default is ""*/
	 	  	/**
	 * style
	 * The component style
	 */
	 	 private String  _style = null; /* Default is ""*/
	 	  	/**
	 * headerClass
	 * The component header style class
	 */
	 	 private String  _headerClass = null; /* Default is null*/
	 	    
// Getters-setters
 	/*
	 * The component content style class
	 * Setter for contentClass
	 * @param contentClass - new value
	 */
	 public void setContentClass( String  __contentClass ){
		this._contentClass = __contentClass;
	 	 }


	/*
	 * The component content style class
	 * Getter for contentClass
	 * @return contentClass value from local variable or value bindings
	 */
	 public String getContentClass(  ){
	         if (null != this._contentClass)
        {
            return this._contentClass;
        	    }
        ValueBinding vb = getValueBinding("contentClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * The component header style
	 * Setter for headerStyle
	 * @param headerStyle - new value
	 */
	 public void setHeaderStyle( String  __headerStyle ){
		this._headerStyle = __headerStyle;
	 	 }


	/*
	 * The component header style
	 * Getter for headerStyle
	 * @return headerStyle value from local variable or value bindings
	 */
	 public String getHeaderStyle(  ){
	         if (null != this._headerStyle)
        {
            return this._headerStyle;
        	    }
        ValueBinding vb = getValueBinding("headerStyle");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * The component style class
	 * Setter for styleClass
	 * @param styleClass - new value
	 */
	 public void setStyleClass( String  __styleClass ){
		this._styleClass = __styleClass;
	 	 }


	/*
	 * The component style class
	 * Getter for styleClass
	 * @return styleClass value from local variable or value bindings
	 */
	 public String getStyleClass(  ){
	         if (null != this._styleClass)
        {
            return this._styleClass;
        	    }
        ValueBinding vb = getValueBinding("styleClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * The width of the slide panel. Might be defined as pixels or as percentage.
	    	The default width is 100%
	 * Setter for width
	 * @param width - new value
	 */
	 public void setWidth( String  __width ){
		this._width = __width;
	 	 }


	/*
	 * The width of the slide panel. Might be defined as pixels or as percentage.
	    	The default width is 100%
	 * Getter for width
	 * @return width value from local variable or value bindings
	 */
	 public String getWidth(  ){
	         if (null != this._width)
        {
            return this._width;
        	    }
        ValueBinding vb = getValueBinding("width");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "100%";
        }
	 	 }
	   	/*
	 * The height of the slide panel. Might be defined as pixels or as percentage.
	    	The default height is 100%
	 * Setter for height
	 * @param height - new value
	 */
	 public void setHeight( String  __height ){
		this._height = __height;
	 	 }


	/*
	 * The height of the slide panel. Might be defined as pixels or as percentage.
	    	The default height is 100%
	 * Getter for height
	 * @return height value from local variable or value bindings
	 */
	 public String getHeight(  ){
	         if (null != this._height)
        {
            return this._height;
        	    }
        ValueBinding vb = getValueBinding("height");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "100%";
        }
	 	 }
	   	/*
	 * The component content style
	 * Setter for contentStyle
	 * @param contentStyle - new value
	 */
	 public void setContentStyle( String  __contentStyle ){
		this._contentStyle = __contentStyle;
	 	 }


	/*
	 * The component content style
	 * Getter for contentStyle
	 * @return contentStyle value from local variable or value bindings
	 */
	 public String getContentStyle(  ){
	         if (null != this._contentStyle)
        {
            return this._contentStyle;
        	    }
        ValueBinding vb = getValueBinding("contentStyle");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * The component style
	 * Setter for style
	 * @param style - new value
	 */
	 public void setStyle( String  __style ){
		this._style = __style;
	 	 }


	/*
	 * The component style
	 * Getter for style
	 * @return style value from local variable or value bindings
	 */
	 public String getStyle(  ){
	         if (null != this._style)
        {
            return this._style;
        	    }
        ValueBinding vb = getValueBinding("style");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * The component header style class
	 * Setter for headerClass
	 * @param headerClass - new value
	 */
	 public void setHeaderClass( String  __headerClass ){
		this._headerClass = __headerClass;
	 	 }


	/*
	 * The component header style class
	 * Getter for headerClass
	 * @return headerClass value from local variable or value bindings
	 */
	 public String getHeaderClass(  ){
	         if (null != this._headerClass)
        {
            return this._headerClass;
        	    }
        ValueBinding vb = getValueBinding("headerClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.PanelBar";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[9];
        values[0] = super.saveState(context);
 	 	          values[1] = _contentClass;
	   	 	
  	 	          values[2] = _headerStyle;
	   	 	
  	 	          values[3] = _styleClass;
	   	 	
  	 	          values[4] = _width;
	   	 	
  	 	          values[5] = _height;
	   	 	
  	 	          values[6] = _contentStyle;
	   	 	
  	 	          values[7] = _style;
	   	 	
  	 	          values[8] = _headerClass;
	   	 	
    	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	 	          _contentClass = (String)values[1] ;
	   	 	
  	 	          _headerStyle = (String)values[2] ;
	   	 	
  	 	          _styleClass = (String)values[3] ;
	   	 	
  	 	          _width = (String)values[4] ;
	   	 	
  	 	          _height = (String)values[5] ;
	   	 	
  	 	          _contentStyle = (String)values[6] ;
	   	 	
  	 	          _style = (String)values[7] ;
	   	 	
  	 	          _headerClass = (String)values[8] ;
	   	 	
    	
		
	}	
// Utilites

}