/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import org.richfaces.component.UISubTable ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.SubTable
 * Component-Family org.richfaces.SubTable
  	 * Renderer-Type org.richfaces.SubTableRenderer
  	 * 
 */
 public class HtmlSubTable extends org.richfaces.component.UISubTable {

  public static final String COMPONENT_TYPE = "org.richfaces.SubTable";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlSubTable (){
  	  	setRendererType("org.richfaces.SubTableRenderer");
  	  }

// Component properties fields
   	/**
	 * rowClasses
	 * A comma-delimited list of CSS style classes that is applied to popup table rows. A space separated list of classes may also be specified for any individual row. Thes styles are applied, in turn, to each row in the table. For example, if the list has two elements, the first style class in the list is applied to the first row, the second to the second row, the first to the third row, the second to the fourth row, etc. In other words, we keep iterating through the list until we reach the end, and then we start at the beginning again.
	 */
	 	 private String  _rowClasses = null; /* Default is null*/
	 	  	/**
	 * onRowClick
	 * 
	 */
	 	 private String  _onRowClick = null; /* Default is null*/
	 	   	/**
	 * onRowDblClick
	 * 
	 */
	 	 private String  _onRowDblClick = null; /* Default is null*/
	 	   	/**
	 * onRowMouseDown
	 * 
	 */
	 	 private String  _onRowMouseDown = null; /* Default is null*/
	 	  	/**
	 * footerClass
	 * Space-separated list of CSS style class(es) that are be applied to any footer generated for this table.
	 */
	 	 private String  _footerClass = null; /* Default is null*/
	 	        	/**
	 * onRowMouseOver
	 * 
	 */
	 	 private String  _onRowMouseOver = null; /* Default is null*/
	 	     	/**
	 * onRowMouseUp
	 * 
	 */
	 	 private String  _onRowMouseUp = null; /* Default is null*/
	 	  	/**
	 * columnClasses
	 * Comma-delimited list of CSS style classes that are be applied to the columns of this table. A space separated list of classes may also be specified for any individual column. If the number of elements in this list is less than the number of columns specified in the "columns" attribute, no "class" attribute is output for each column greater than the number of elements in the list. If the number of elements in the list is greater than the number of columns specified in the "columns" attribute, the elements at the posisiton in the list after the value of the "columns" attribute are ignored.
	 */
	 	 private String  _columnClasses = null; /* Default is null*/
	 	    	/**
	 * headerClass
	 * Space-separated list of CSS style class(es) that are be applied to any header generated for this table.
	 */
	 	 private String  _headerClass = null; /* Default is null*/
	 	  	/**
	 * onRowMouseMove
	 * 
	 */
	 	 private String  _onRowMouseMove = null; /* Default is null*/
	 	  	/**
	 * onRowMouseOut
	 * 
	 */
	 	 private String  _onRowMouseOut = null; /* Default is null*/
	 	    
// Getters-setters
   	/*
	 * A comma-delimited list of CSS style classes that is applied to popup table rows. A space separated list of classes may also be specified for any individual row. Thes styles are applied, in turn, to each row in the table. For example, if the list has two elements, the first style class in the list is applied to the first row, the second to the second row, the first to the third row, the second to the fourth row, etc. In other words, we keep iterating through the list until we reach the end, and then we start at the beginning again.
	 * Setter for rowClasses
	 * @param rowClasses - new value
	 */
	 public void setRowClasses( String  __rowClasses ){
		this._rowClasses = __rowClasses;
	 	 }


	/*
	 * A comma-delimited list of CSS style classes that is applied to popup table rows. A space separated list of classes may also be specified for any individual row. Thes styles are applied, in turn, to each row in the table. For example, if the list has two elements, the first style class in the list is applied to the first row, the second to the second row, the first to the third row, the second to the fourth row, etc. In other words, we keep iterating through the list until we reach the end, and then we start at the beginning again.
	 * Getter for rowClasses
	 * @return rowClasses value from local variable or value bindings
	 */
	 public String getRowClasses(  ){
	         if (null != this._rowClasses)
        {
            return this._rowClasses;
        	    }
        ValueBinding vb = getValueBinding("rowClasses");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * 
	 * Setter for onRowClick
	 * @param onRowClick - new value
	 */
	 public void setOnRowClick( String  __onRowClick ){
		this._onRowClick = __onRowClick;
	 	 }


	/*
	 * 
	 * Getter for onRowClick
	 * @return onRowClick value from local variable or value bindings
	 */
	 public String getOnRowClick(  ){
	         if (null != this._onRowClick)
        {
            return this._onRowClick;
        	    }
        ValueBinding vb = getValueBinding("onRowClick");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * 
	 * Setter for onRowDblClick
	 * @param onRowDblClick - new value
	 */
	 public void setOnRowDblClick( String  __onRowDblClick ){
		this._onRowDblClick = __onRowDblClick;
	 	 }


	/*
	 * 
	 * Getter for onRowDblClick
	 * @return onRowDblClick value from local variable or value bindings
	 */
	 public String getOnRowDblClick(  ){
	         if (null != this._onRowDblClick)
        {
            return this._onRowDblClick;
        	    }
        ValueBinding vb = getValueBinding("onRowDblClick");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * 
	 * Setter for onRowMouseDown
	 * @param onRowMouseDown - new value
	 */
	 public void setOnRowMouseDown( String  __onRowMouseDown ){
		this._onRowMouseDown = __onRowMouseDown;
	 	 }


	/*
	 * 
	 * Getter for onRowMouseDown
	 * @return onRowMouseDown value from local variable or value bindings
	 */
	 public String getOnRowMouseDown(  ){
	         if (null != this._onRowMouseDown)
        {
            return this._onRowMouseDown;
        	    }
        ValueBinding vb = getValueBinding("onRowMouseDown");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Space-separated list of CSS style class(es) that are be applied to any footer generated for this table.
	 * Setter for footerClass
	 * @param footerClass - new value
	 */
	 public void setFooterClass( String  __footerClass ){
		this._footerClass = __footerClass;
	 	 }


	/*
	 * Space-separated list of CSS style class(es) that are be applied to any footer generated for this table.
	 * Getter for footerClass
	 * @return footerClass value from local variable or value bindings
	 */
	 public String getFooterClass(  ){
	         if (null != this._footerClass)
        {
            return this._footerClass;
        	    }
        ValueBinding vb = getValueBinding("footerClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	         	/*
	 * 
	 * Setter for onRowMouseOver
	 * @param onRowMouseOver - new value
	 */
	 public void setOnRowMouseOver( String  __onRowMouseOver ){
		this._onRowMouseOver = __onRowMouseOver;
	 	 }


	/*
	 * 
	 * Getter for onRowMouseOver
	 * @return onRowMouseOver value from local variable or value bindings
	 */
	 public String getOnRowMouseOver(  ){
	         if (null != this._onRowMouseOver)
        {
            return this._onRowMouseOver;
        	    }
        ValueBinding vb = getValueBinding("onRowMouseOver");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      	/*
	 * 
	 * Setter for onRowMouseUp
	 * @param onRowMouseUp - new value
	 */
	 public void setOnRowMouseUp( String  __onRowMouseUp ){
		this._onRowMouseUp = __onRowMouseUp;
	 	 }


	/*
	 * 
	 * Getter for onRowMouseUp
	 * @return onRowMouseUp value from local variable or value bindings
	 */
	 public String getOnRowMouseUp(  ){
	         if (null != this._onRowMouseUp)
        {
            return this._onRowMouseUp;
        	    }
        ValueBinding vb = getValueBinding("onRowMouseUp");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Comma-delimited list of CSS style classes that are be applied to the columns of this table. A space separated list of classes may also be specified for any individual column. If the number of elements in this list is less than the number of columns specified in the "columns" attribute, no "class" attribute is output for each column greater than the number of elements in the list. If the number of elements in the list is greater than the number of columns specified in the "columns" attribute, the elements at the posisiton in the list after the value of the "columns" attribute are ignored.
	 * Setter for columnClasses
	 * @param columnClasses - new value
	 */
	 public void setColumnClasses( String  __columnClasses ){
		this._columnClasses = __columnClasses;
	 	 }


	/*
	 * Comma-delimited list of CSS style classes that are be applied to the columns of this table. A space separated list of classes may also be specified for any individual column. If the number of elements in this list is less than the number of columns specified in the "columns" attribute, no "class" attribute is output for each column greater than the number of elements in the list. If the number of elements in the list is greater than the number of columns specified in the "columns" attribute, the elements at the posisiton in the list after the value of the "columns" attribute are ignored.
	 * Getter for columnClasses
	 * @return columnClasses value from local variable or value bindings
	 */
	 public String getColumnClasses(  ){
	         if (null != this._columnClasses)
        {
            return this._columnClasses;
        	    }
        ValueBinding vb = getValueBinding("columnClasses");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     	/*
	 * Space-separated list of CSS style class(es) that are be applied to any header generated for this table.
	 * Setter for headerClass
	 * @param headerClass - new value
	 */
	 public void setHeaderClass( String  __headerClass ){
		this._headerClass = __headerClass;
	 	 }


	/*
	 * Space-separated list of CSS style class(es) that are be applied to any header generated for this table.
	 * Getter for headerClass
	 * @return headerClass value from local variable or value bindings
	 */
	 public String getHeaderClass(  ){
	         if (null != this._headerClass)
        {
            return this._headerClass;
        	    }
        ValueBinding vb = getValueBinding("headerClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * 
	 * Setter for onRowMouseMove
	 * @param onRowMouseMove - new value
	 */
	 public void setOnRowMouseMove( String  __onRowMouseMove ){
		this._onRowMouseMove = __onRowMouseMove;
	 	 }


	/*
	 * 
	 * Getter for onRowMouseMove
	 * @return onRowMouseMove value from local variable or value bindings
	 */
	 public String getOnRowMouseMove(  ){
	         if (null != this._onRowMouseMove)
        {
            return this._onRowMouseMove;
        	    }
        ValueBinding vb = getValueBinding("onRowMouseMove");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * 
	 * Setter for onRowMouseOut
	 * @param onRowMouseOut - new value
	 */
	 public void setOnRowMouseOut( String  __onRowMouseOut ){
		this._onRowMouseOut = __onRowMouseOut;
	 	 }


	/*
	 * 
	 * Getter for onRowMouseOut
	 * @return onRowMouseOut value from local variable or value bindings
	 */
	 public String getOnRowMouseOut(  ){
	         if (null != this._onRowMouseOut)
        {
            return this._onRowMouseOut;
        	    }
        ValueBinding vb = getValueBinding("onRowMouseOut");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.SubTable";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[12];
        values[0] = super.saveState(context);
   	 	          values[1] = _rowClasses;
	   	 	
  	 	          values[2] = _onRowClick;
	   	 	
   	 	          values[3] = _onRowDblClick;
	   	 	
   	 	          values[4] = _onRowMouseDown;
	   	 	
  	 	          values[5] = _footerClass;
	   	 	
        	 	          values[6] = _onRowMouseOver;
	   	 	
     	 	          values[7] = _onRowMouseUp;
	   	 	
  	 	          values[8] = _columnClasses;
	   	 	
    	 	          values[9] = _headerClass;
	   	 	
  	 	          values[10] = _onRowMouseMove;
	   	 	
  	 	          values[11] = _onRowMouseOut;
	   	 	
    	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
   	 	          _rowClasses = (String)values[1] ;
	   	 	
  	 	          _onRowClick = (String)values[2] ;
	   	 	
   	 	          _onRowDblClick = (String)values[3] ;
	   	 	
   	 	          _onRowMouseDown = (String)values[4] ;
	   	 	
  	 	          _footerClass = (String)values[5] ;
	   	 	
        	 	          _onRowMouseOver = (String)values[6] ;
	   	 	
     	 	          _onRowMouseUp = (String)values[7] ;
	   	 	
  	 	          _columnClasses = (String)values[8] ;
	   	 	
    	 	          _headerClass = (String)values[9] ;
	   	 	
  	 	          _onRowMouseMove = (String)values[10] ;
	   	 	
  	 	          _onRowMouseOut = (String)values[11] ;
	   	 	
    	
		
	}	
// Utilites

}