/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.model;

/**
 * Tab model bean represent a single tab in list of tabs for panel.
 * @author shura (latest modification by $Author: ishabalov $)
 * @version $Revision: 1.3 $ $Date: 2007/02/21 20:35:05 $
 *
 */
public class Tab implements TabModel {

	private Object _name;
	private String _label;
	private boolean _disabled;
	private String _labelWidth;
//	private String _description;
	private String _switchType;
	private String _title;
	
	
	/**
	 *  No-argument constructor for JavaBean contract.
	 */
	public Tab() {
		super();
	}
	
	public Tab(Object value) {
		this(value,value.toString(),false,null,null);
	}
	/**
	 * @param value
	 * @param label
	 * @param disabled
	 * @param labelWidth
	 * @param title
	 */
	public Tab(Object value, String label, boolean disabled, String labelWidth, String title) {
		super();
		this._name = value;
		this._label = label;
		this._disabled = disabled;
		this._labelWidth = labelWidth;
		this._title = title;
//		this._description = description;
	}
	/**
	 * @return Returns the description.
	 */
/*	public String getDescription() {
		return this._description;
	}*/
	/**
	 * @param description The description to set.
	 */
/*	public void setDescription(String description) {
		this._description = description;
	}*/
	/**
	 * @return Returns the disabled.
	 */
	public boolean isDisabled() {
		return this._disabled;
	}
	/**
	 * @param disabled The disabled to set.
	 */
	public void setDisabled(boolean disabled) {
		this._disabled = disabled;
	}
	/**
	 * @return Returns the label.
	 */
	public String getLabel() {
		return this._label;
	}
	/**
	 * @param label The label to set.
	 */
	public void setLabel(String label) {
		this._label = label;
	}
	/**
	 * @return Returns the labelWidth.
	 */
	public String getLabelWidth() {
		return this._labelWidth;
	}
	/**
	 * @param labelWidth The labelWidth to set.
	 */
	public void setLabelWidth(String labelWidth) {
		this._labelWidth = labelWidth;
	}
	/**
	 * @return Returns the value.
	 */
	public Object getName() {
		return this._name;
	}
	/**
	 * @param value The value to set.
	 */
	public void setName(Object value) {
		if(value == null) {
			throw new NullPointerException("value for tab set to null");
		}
		this._name = value;
	}

	/**
	 * @return Returns the switchType.
	 */
	public String getSwitchType() {
		return _switchType;
	}

	/**
	 * @param switchType The switchType to set.
	 */
	public void setSwitchType(String switchType) {
		_switchType = switchType;
	}
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return _title;
	}
	/**
	 * @param title The title to set.
	 */
	public void setTitle(String newvalue) {
		this._title = newvalue;
		
	}
	
}
