package org.richfaces.taglib;

import java.lang.String ;
import java.lang.Object ;
import javax.faces.el.MethodBinding ;
import com.sun.facelets.tag.jsf.ComponentHandler ;
import javax.faces.component.UIComponent;
import org.richfaces.component.html.HtmlDatascroller;
import com.sun.facelets.tag.jsf.ComponentHandler;
import com.sun.facelets.tag.jsf.ComponentConfig;

import com.sun.facelets.*;
import com.sun.facelets.el.*;
import com.sun.facelets.tag.*;
/**
 * @author shura (latest modification by $Author: ishabalov $)
 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
 *
 */
public class DataScrollerTagHandler extends com.sun.facelets.tag.jsf.ComponentHandler {


  private static final DataScrollerTagHandlerMetaRule metaRule = new DataScrollerTagHandlerMetaRule();


  
  public DataScrollerTagHandler(ComponentConfig config) 
  {
    super(config);
  }
// Metarule
  protected MetaRuleset createMetaRuleset(Class type)
  {
    MetaRuleset m = super.createMetaRuleset(type);
	m.addRule(metaRule);
	return m;
  }

  	/**
	 * @author shura (latest modification by $Author: ishabalov $)
	 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
	 *
	 */
	static class DataScrollerTagHandlerMetaRule extends MetaRule{

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.MetaRule#applyRule(java.lang.String, com.sun.facelets.tag.TagAttribute, com.sun.facelets.tag.MetadataTarget)
		 */
		public Metadata applyRule(String name, TagAttribute attribute, MetadataTarget meta) {
	        if (meta.isTargetInstanceOf(HtmlDatascroller.class)) {
				 		  		 				 		  		 				 		  		 				 				 		  		 				 		  		 				 		  		 				 				 				 				 		  		 				 				 				 		  		 				 				 				 				 				 		  		 				 		  		 				 				 				 				 				 		  	            if ("actionListener".equals(name)) {
	                    return new actionListenerMapper(attribute);
	            }

		  		 				 		  		 				 		  		 				 		  		 				 				 				 		  		 				 				 		  		 				 				 				 		  		 				 				 		  		 				 		  		 				 				 		  	            if ("action".equals(name)) {
	                    return new actionMapper(attribute);
	            }

		  		 				 				 				 		  		 				 				 		  	            if ("scrollerListener".equals(name)) {
	                    return new scrollerListenerMapper(attribute);
	            }

		  		 				 				 		  		 				 		  		 				 		  		 				 		  		 				 				 				 		  		 			        }
			return null;
		}

	}


    
    
     
    
    
       
      
        
    
        
  	
	static class actionListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {javax.faces.event.ActionEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public actionListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlDatascroller) instance)
            .setActionListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	  
    
    
      
     
      
     
    
     
  	
	static class actionMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public actionMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlDatascroller) instance)
            .setAction(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	    
     
  	
	static class scrollerListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {org.richfaces.event.DataScrollerEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public scrollerListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlDatascroller) instance)
            .setScrollerListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	   
    
    
    
      
    }
