package org.richfaces.taglib;

import java.lang.String;
import javax.faces.convert.Converter;
import java.lang.Object;
import javax.faces.el.MethodBinding;
import com.sun.facelets.tag.jsf.ComponentHandler;
import javax.faces.component.UIComponent;
import org.richfaces.component.UISuggestionBox;
import com.sun.facelets.tag.jsf.ComponentHandler;
import com.sun.facelets.tag.jsf.ComponentConfig;

import com.sun.facelets.*;
import com.sun.facelets.el.*;
import com.sun.facelets.tag.*;

/**
 * @author shura (latest modification by $Author: ishabalov $)
 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
 *
 */
public class SuggestionBoxTagHandler extends
		com.sun.facelets.tag.jsf.ComponentHandler {

	private static final SuggestionBoxTagHandlerMetaRule metaRule = new SuggestionBoxTagHandlerMetaRule();

	public SuggestionBoxTagHandler(ComponentConfig config) {
		super(config);
	}

	// Metarule
	protected MetaRuleset createMetaRuleset(Class type) {
		MetaRuleset m = super.createMetaRuleset(type);
		m.addRule(metaRule);
		return m;
	}

	/**
	 * @author shura (latest modification by $Author: ishabalov $)
	 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
	 *
	 */
	static class SuggestionBoxTagHandlerMetaRule extends MetaRule {

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.MetaRule#applyRule(java.lang.String, com.sun.facelets.tag.TagAttribute, com.sun.facelets.tag.MetadataTarget)
		 */
		public Metadata applyRule(String name, TagAttribute attribute,
				MetadataTarget meta) {
			if (meta.isTargetInstanceOf(UISuggestionBox.class)) {
				if ("suggestionAction".equals(name)) {
					return new suggestionActionMapper(attribute);
				}

			}
			return null;
		}

	}

	static class suggestionActionMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] { java.lang.Object.class };

		private final TagAttribute _action;

		/**
		 * @param attribute
		 */
		public suggestionActionMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
			((UISuggestionBox) instance)
					.setSuggestionAction(new LegacyMethodBinding(this._action
							.getMethodExpression(ctx, null, SIGNATURE)));
		}

	}

}
